#========================================================================================
# package      DE_EPAGES::CreditCheck::t::TestCreditCheckAgencyConfig
# state        public
#----------------------------------------------------------------------------------------
# description  Tests in the package CreditCheckAgencyConfig the method storeCheckResult
#========================================================================================
package TestCreditCheckAgencyConfig;
use strict;

use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::CreditCheck::API::Object::CreditCheckAgencyConfig;
use Test::More;
use Test::MockObject;
my $mCreditCheckAgencyConfig = Test::MockObject->new();
my $mBasket = Test::MockObject->new();
sub Main {
    init_Mock();
    storeCheckResult_PositiveResultBehavior(undef,0);
    storeCheckResult_PositiveResultBehavior('',0);
    storeCheckResult_PositiveResultBehavior(0,0);
    storeCheckResult_PositiveResultBehavior(1,1);
    storeCheckResult_PositiveResultBehavior('StringValue','StringValue');
    done_testing();
}

sub storeCheckResult_PositiveResultBehavior {
    my ($PositiveResult,$ExpectedValue) = @_;
    my $TestName = (caller(0))[3];

    DE_EPAGES::CreditCheck::API::Object::CreditCheckAgencyConfig::storeCheckResult($mCreditCheckAgencyConfig,$mBasket,'ScoreValue',$PositiveResult);
    is($mCreditCheckAgencyConfig->{'NameOfChild'},'CreditCheckCheckResults',"$TestName - Test if this is the correct child name - CreditCheckCheckResults");
    my $aExpectedResult = {
            'Alias' => 'CheckResultBasketID',
            'Score' => 'ScoreValue',
            'BasketID' => 'BasketID',
            'CreditCheckAgencyID' => 'CreditCheckAgencyID',
            'PositiveResult' => $ExpectedValue
    };
    is_deeply($mCreditCheckAgencyConfig->{'TestParams'}, $aExpectedResult, "$TestName - Test the values which would be handed over to insertChild - hash");
}

sub init_Mock{
    $mCreditCheckAgencyConfig->set_always('folder',$mCreditCheckAgencyConfig);
    $mCreditCheckAgencyConfig->set_always('get',$mCreditCheckAgencyConfig);
    $mCreditCheckAgencyConfig->set_always('id','CreditCheckAgencyID');
    $mCreditCheckAgencyConfig->mock('insertChild', sub {
            my $self = shift;
            my ( $NameOfChild, $hParams ) = @_;
            $self->{'NameOfChild'} = $NameOfChild;
            $self->{'TestParams'}  = $hParams;
            return;
     });

     $mBasket->set_always('id','BasketID');
}
RunScript( Sub => \&Main );