package TestUI_UniversalPortal;
use strict;

use DE_EPAGES::Core::API::Script qw ( RunScript );
use Test::MockObject;
use DE_EPAGES::UniversalPortal::UI::UniversalConfig;
use DE_EPAGES::UniversalPortal::API::Object::UniversalPortalConfig;
use Test::More;

sub Main {
    my $MockedServlet = BuildMockServlet();
    TestExportPortalConfigWithoutChild($MockedServlet);
    done_testing();
}

sub TestExportPortalConfigWithoutChild {
    my ($MockedServlet) = @_;
    my $subTestName = (caller(0))[3];
    DE_EPAGES::UniversalPortal::UI::UniversalConfig->ExportPortalConfig($MockedServlet);
    is_deeply( $MockedServlet->{'ErrorAsHash'},
              { 'Reason'=> 'NoAttributesForExport', 'Form'  => 'ExportPortalConfig', 'Name'  => 'ExportPortalConfig', },
              "$subTestName - check ErrorMessage - Error Hash"
    );
    is($MockedServlet->{'executeFormError'},'WasExecuted',"$subTestName - was executeFormError called - WasExecuted");
}

# mocking
sub BuildMockServlet {
    my $Mock = Test::MockObject->new();
    $Mock->mock('form', sub {
            return $Mock;
    });
    $Mock->mock('object', sub {
            return BuildMockPortalConfig();
    });
    $Mock->mock('addFormError', sub {
        my $self = shift;
        my ($ErrorAsHash) = @_;
        $Mock->{'ErrorAsHash'} = $ErrorAsHash;
    });
    $Mock->mock('executeFormError', sub {
            $Mock->{'executeFormError'} = 'WasExecuted';
    });
    return $Mock;
}

sub BuildMockPortalConfig {
    my $Mock = Test::MockObject->new();
    $Mock->mock('get', sub {
            my $self = shift;
            my ($AttributeName) = @_;
            my $hAttributes = {
                    'UniversalPortalAttributeSets' => [],
            };
            return $hAttributes->{$AttributeName};
    });
}

RunScript( Sub => \&Main );